#pragma once
#include "Thing.h"
#include "Header.h"

class FirstStage :
	public Thing
{
private:
	std::chrono::steady_clock::time_point start;
	std::chrono::steady_clock::time_point finish;
	long double timeElapsed = 0;
	SDL_Surface *firststage;
	SDL_Rect firstStageTarget;
	SDL_Texture * firstStageTexture;
	SDL_Color textColor;
	std::string getReady = "GET READY FOR STAGE 1";
	const char *FIRST;
public:
	virtual void initiate(int i) {
		textColor = { 255, 255, 255 };
		firstStageTarget.x = 300; firstStageTarget.y = 250; firstStageTarget.h = 80; firstStageTarget.w = 400;
	}
	virtual void update(int i) {
		if (Globalfirststage == true)
		{
			SDL_FreeSurface(firststage);
			SDL_DestroyTexture(firstStageTexture);
			FIRST = getReady.c_str();
			firststage = TTF_RenderText_Solid(font, FIRST, textColor);
			firstStageTexture = SDL_CreateTextureFromSurface(renderer, firststage);
			SDL_RenderCopy(renderer, firstStageTexture, NULL, &firstStageTarget);
			SDL_RenderPresent(renderer);
			start = std::chrono::steady_clock::now();
			while (true) {
				finish = std::chrono::steady_clock::now();
				timeElapsed = std::chrono::duration_cast<std::chrono::nanoseconds>(finish - start).count();
				if (timeElapsed >= 3000000000) break;
			}
			timeElapsed = 0;
			Globalfirststage = false;
			EnemiesLeft = 55;
		}
	}

	virtual void destroy(int i) {
		SDL_FreeSurface(firststage);
		SDL_DestroyTexture(firstStageTexture);
	}

	FirstStage()
	{
	}
	~FirstStage()
	{
	}
};

