#pragma once
#include "Thing.h"
#include "Header.h"

class SoundFX :
	public Thing
{
private:
	bool initiated = false;
	Mix_Chunk *EnemyExplosion;
	Mix_Chunk *EnemyLaser;
	Mix_Chunk *BarrierExplosion;
	Mix_Chunk *PlayerLaser;
	Mix_Chunk *PlayerExplosion;
	Mix_Chunk *A;
	Mix_Chunk *B;
	Mix_Chunk *C;
	Mix_Chunk *D;
	Mix_Chunk *UFO_WootWoot;

	
	int u;
	bool CycleUsed = false;
	bool clockStarted = false;
	std::chrono::steady_clock::time_point start;
	std::chrono::steady_clock::time_point finish;
	long double timeElapsed = 0;
	enum music {A_, B_, C_, D_};
	music m;
	bool tonePlays = false;
	bool UFO_Woot_Trigger = false;
public:
	virtual void initiate(int i) {
		if (initiated == false) {
			Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
			Mix_AllocateChannels(64);
			EnemyExplosion = Mix_LoadWAV("phaseboom.wav");
			EnemyLaser = Mix_LoadWAV("shortlaser.wav");
			BarrierExplosion = Mix_LoadWAV("highboom.wav");
			PlayerLaser = Mix_LoadWAV("longlaser.wav");
			PlayerExplosion = Mix_LoadWAV("phaseboom2.wav");
			A = Mix_LoadWAV("300hz219ms.wav");
			B = Mix_LoadWAV("278hz219ms.wav");
			C = Mix_LoadWAV("250hz219ms.wav");
			D = Mix_LoadWAV("232hz219ms.wav");
			UFO_WootWoot = Mix_LoadWAV("UFOwootwoot.wav");
			
			initiated = true;
		}
		for (u = 0; u < 32; u++) {
			FX_QUEUE[u] = SILENCE_PUSH;
		}
		m = A_; //Set first tone
		UFO_[0] = SILENCE_PUSH;
	}
	virtual void update(int i) {
		if (loadUfo == true) {
			loadUfo = false;
		}
		if (UFO_[0] == UFO_PUSH) { Mix_PlayChannel(5, UFO_WootWoot, -1); UFO_[0] = SILENCE_PUSH; }
		CycleUsed = false;
		for (u = 0; u < 32; u++) {
			if (FX_QUEUE[u] != SILENCE_PUSH) {// && CycleUsed == false) {
				if (FX_QUEUE[u] == ENEMYEXPLOSION_PUSH)   Mix_PlayChannel(-1, EnemyExplosion, 0);
				else if (FX_QUEUE[u] == ENEMYLASER_PUSH) Mix_PlayChannel(-1, EnemyLaser, 0);
				else if (FX_QUEUE[u] == PLAYERLASER_PUSH) Mix_PlayChannel(-1, PlayerLaser, 0);
				else if (FX_QUEUE[u] == PLAYEREXPLOSION_PUSH) Mix_PlayChannel(-1, PlayerExplosion, 0);
				else if (FX_QUEUE[u] == BARRIEREXPLOSION_PUSH) Mix_PlayChannel(-1, BarrierExplosion, 0);
				//else if (FX_QUEUE[u] == UFO_PUSH) Mix_PlayChannel(5,UFO_WootWoot, -1);
				//if(FX_QUEUE[u] != UFO_PUSH)	
				FX_QUEUE[u] = SILENCE_PUSH;
				//lastSoundSlot = u;
				//CycleUsed = true;
			};
		}
		//if (lastSoundSlot == 31) lastSoundSlot = 0;
		//if (CycleUsed == true) {
		//	for (u = 1; u < 33; u++) {
				//if (FX_QUEUE[u] != SILENCE_PUSH)
		//			FX_QUEUE[u - 1] = FX_QUEUE[u];
		//	}
		//}
		// Music cascade
		if (clockStarted == false) {
			clockStarted = true;
			start = std::chrono::steady_clock::now();
		}
		finish = std::chrono::steady_clock::now();
		timeElapsed = std::chrono::duration_cast<std::chrono::nanoseconds>(finish - start).count();
		if ((moveTreshold > 50000000 && timeElapsed >= moveTreshold * 2) || (moveTreshold <= 50000000 && timeElapsed >= 100000000)) {
			if (m == A_) {
				Mix_PlayChannel(-1, A, 0);
				m = B_;
			}
			else if (m == B_) {
				Mix_PlayChannel(-1, B, 0);
				m = C_;
			}
			else if (m == C_) {
				Mix_PlayChannel(-1, C, 0);
				m = D_;
			}
			else if (m == D_) {
				Mix_PlayChannel(-1, D, 0);
				m = A_;
			}
			clockStarted = false;
		}
	}
	virtual void destroy(int i) {
		Mix_FreeChunk(EnemyExplosion);
		Mix_FreeChunk(EnemyLaser);
		Mix_FreeChunk(BarrierExplosion);
		Mix_FreeChunk(PlayerLaser);
		Mix_FreeChunk(PlayerExplosion);
		Mix_FreeChunk(A);
		Mix_FreeChunk(B);
		Mix_FreeChunk(C);
		Mix_FreeChunk(D);
		Mix_FreeChunk(UFO_WootWoot);
		Mix_CloseAudio();
	}
	SoundFX()
	{
	}
	~SoundFX()
	{
	}
};

