#pragma once
#include "Thing.h"
#include "Header.h"

class Start :
	public Thing
{
private:
	SDL_Surface *start;
	SDL_Rect StartTarget;
	SDL_Texture * StartTexture;
	SDL_Color textColor;

	SDL_Surface *intruders;
	SDL_Rect IntrudersTarget;
	SDL_Texture * IntrudersTexture;

	//TEXT ON BOTTOM
	SDL_Surface *StartGame;
	SDL_Rect StartGameTarget;
	SDL_Texture *StartGameTexture;

	SDL_Surface *ViewHighScore;
	SDL_Rect ViewHighScoreTarget;
	SDL_Texture *ViewHighScoreTexture;

	//THE PICTURE
	SDL_Surface *startSurface;
	SDL_Rect startTarget;
	SDL_Texture *startTexture;

	//HISCORE BOARD
	SDL_Surface *namesSurface;
	SDL_Rect namesTarget;
	SDL_Texture *namesTexture;
	SDL_Surface *scoresSurface;
	SDL_Rect scoresTarget;
	SDL_Texture *scoresTexture;
	std::string names;
	std::string scores;
	bool hiScoreBlock;
	
	int mouseX;
	int mouseY;

	bool waiting = true;
	bool initiated = false;

	std::chrono::steady_clock::time_point go;
	std::chrono::steady_clock::time_point finish;
	long double timeElapsed = 0;
	Mix_Music *Encounter;


public:
	virtual void initiate(int i) {
		if (initiated == false) {
			SDL_FreeSurface(start);
			SDL_DestroyTexture(StartTexture);
			textColor = { 255, 255, 255 };
			start = TTF_RenderText_Solid(font, "COSMIC", textColor);
			StartTexture = SDL_CreateTextureFromSurface(renderer, start);
			StartTarget.x = 300; StartTarget.y = 50; StartTarget.h = 100; StartTarget.w = 400;

			SDL_FreeSurface(intruders);
			SDL_DestroyTexture(IntrudersTexture);
			intruders = TTF_RenderText_Solid(font, "INTRUDERS", textColor);
			IntrudersTexture = SDL_CreateTextureFromSurface(renderer, intruders);
			IntrudersTarget.x = 200; IntrudersTarget.y = 140; IntrudersTarget.h = 100; IntrudersTarget.w = 600;

			SDL_FreeSurface(StartGame);
			SDL_DestroyTexture(StartGameTexture);
			StartGame = TTF_RenderText_Solid(font, "START GAME", textColor);
			StartGameTexture = SDL_CreateTextureFromSurface(renderer, StartGame);
			StartGameTarget.x = 50; StartGameTarget.y = 480; StartGameTarget.h = 100; StartGameTarget.w = 300;
			
			SDL_FreeSurface(ViewHighScore);
			SDL_DestroyTexture(ViewHighScoreTexture);
			ViewHighScore = TTF_RenderText_Solid(font, "VIEW HI-SCORES", textColor);
			ViewHighScoreTexture = SDL_CreateTextureFromSurface(renderer, ViewHighScore);
			ViewHighScoreTarget.x = 650; ViewHighScoreTarget.y = 480; ViewHighScoreTarget.h = 100; ViewHighScoreTarget.w = 300;
			
			SDL_FreeSurface(startSurface);
			SDL_DestroyTexture(startTexture);
			startSurface = SDL_LoadBMP("start.bmp");
			SDL_SetColorKey(startSurface, SDL_TRUE, SDL_MapRGB(startSurface->format, 255, 0, 255));
			startTexture = SDL_CreateTextureFromSurface(renderer, startSurface);
			startTarget.x = 250; startTarget.w = 500; startTarget.y = 240; startTarget.h = 300;
			initiated = true;

			SDL_FreeSurface(StartGame);
			SDL_DestroyTexture(StartGameTexture);
			StartGame = TTF_RenderText_Solid(font, "START GAME", textColor);
			StartGameTexture = SDL_CreateTextureFromSurface(renderer, StartGame);
			StartGameTarget.x = 50; StartGameTarget.y = 480; StartGameTarget.h = 100; StartGameTarget.w = 300;

			SDL_FreeSurface(namesSurface);
			SDL_DestroyTexture(namesTexture);
			namesTarget.x = 650; namesTarget.w = 200; namesTarget.y = 240; namesTarget.h = 300;

			SDL_FreeSurface(scoresSurface);
			SDL_DestroyTexture(scoresTexture);
			scoresTarget.x = 900; scoresTarget.w = 200; scoresTarget.y = 240; scoresTarget.h = 300;

			
			
		}
	}


	virtual void update(int i) {
		if (startScreen == true) {
		
			Encounter = Mix_LoadMUS("encounter.wav");
			Mix_PlayMusic(Encounter, -1);
		
			hiScoreBlock = false;
			SDL_RenderCopy(renderer, StartTexture, NULL, &StartTarget);
			SDL_RenderCopy(renderer, IntrudersTexture, NULL, &IntrudersTarget);
			SDL_RenderCopy(renderer, StartGameTexture, NULL, &StartGameTarget);
			SDL_RenderCopy(renderer, ViewHighScoreTexture, NULL, &ViewHighScoreTarget);
			SDL_RenderCopy(renderer, startTexture, NULL, &startTarget);
			SDL_RenderPresent(renderer);
			go = std::chrono::steady_clock::now();
			SDL_SetRelativeMouseMode(SDL_FALSE);
			while (waiting == true) {
				while (SDL_PollEvent(&event) != 0) {
					switch (event.type)
					{
					case SDL_MOUSEBUTTONDOWN:
						SDL_GetMouseState(&mouseX, &mouseY);
						if (mouseX >= 50 && mouseX <= 350 && mouseY >= 480 && mouseY <= 580) {
							waiting = false;
							break;
						}
						if (mouseX >= 650 && mouseX <= 850 && mouseY >= 480 && mouseY <= 580 && hiScoreBlock == false) {
							std::multimap<int, std::string>::reverse_iterator rit;
							names = ""; scores = "";
							for (rit = globalHISCOREMAP.rbegin(); rit != globalHISCOREMAP.rend(); ++rit) { //REVERSE ITERATING: STARTS WITH HIGHEST SCORE
								std::string addName; std::string addScore;
								addName = rit->second; addScore = std::to_string(rit->first);
								names = names + addName + "\n"; scores = scores + addScore + "\n"; // (rit->second).c_str; // << " => " << rit->second << '\n';
							}
							namesSurface = TTF_RenderText_Blended_Wrapped(font, names.c_str(), textColor, 100);
							namesTexture = SDL_CreateTextureFromSurface(renderer, namesSurface);
							SDL_RenderCopy(renderer,namesTexture, NULL, &namesTarget);
							scoresSurface = TTF_RenderText_Blended_Wrapped(font, scores.c_str(), textColor, 100);
							scoresTexture = SDL_CreateTextureFromSurface(renderer, scoresSurface);
							SDL_RenderCopy(renderer, scoresTexture, NULL, &scoresTarget);
							SDL_RenderPresent(renderer);
							hiScoreBlock = true;
							break;
						}
					}
					break;
					}
				finish = std::chrono::steady_clock::now();
				timeElapsed = std::chrono::duration_cast<std::chrono::nanoseconds>(finish - go).count();
				if (timeElapsed >= 30000000000) {
					waiting = false;
					demoMode = true;
				}
				}
			}
		Mix_HaltMusic();
		Mix_FreeMusic(Encounter);
		loadUfo = true;
		
			startScreen = false;
			waiting = true;
			SDL_SetRelativeMouseMode(SDL_TRUE);
		}
	
	virtual void destroy(int i) {
		SDL_FreeSurface(start);
		SDL_DestroyTexture(StartTexture);
		SDL_FreeSurface(intruders);
		SDL_DestroyTexture(IntrudersTexture);
		SDL_FreeSurface(StartGame);
		SDL_DestroyTexture(StartGameTexture);
		SDL_FreeSurface(ViewHighScore);
		SDL_DestroyTexture(ViewHighScoreTexture);
		SDL_FreeSurface(startSurface);
		SDL_DestroyTexture(startTexture);
	}
	
	Start()
	{
	}

	~Start()
	{
	}
};

