#pragma once
#include <SDL.h>
#include <SDL_ttf.h>
#include <map>
#include <string>
#include <chrono>
class Thing 
{
public:
	static SDL_Window *window;
	static SDL_Renderer *renderer;
	static SDL_Event event;
	
	static void initWindow(SDL_Window* &window);
	static void initRenderer(SDL_Renderer * &renderer);

	static TTF_Font* font;
	static void initFont(TTF_Font* &font);

	static void initBorders(SDL_Rect &RightBorder, SDL_Rect &LeftBorder);
	static void initbarrierRessource(SDL_Surface * &barrierSurface, SDL_Texture * &barrierTexture, SDL_Rect &barrierSource);
	static void initlittleGrey(SDL_Surface * &littleGreySurface, SDL_Texture * &littleGreyTexture);
	
	static void initTripod(SDL_Surface * &tripodBodySurface, SDL_Texture * &tripodBodyTexture);
	static void inittakoRessource(SDL_Surface * &takoSurface, SDL_Texture * &takoTexture);
	static void initexplosionRessource(SDL_Surface * &explosionSurface, SDL_Texture * &explosionTexture);

	//global game stuff
	static std::multimap <int, std::string> globalHISCOREMAP;
	static int lowestHighScore;
	static int stage; 
	static bool startScreen;
	//static int maxNumberThings;

	static std::chrono::steady_clock::time_point begin;
	static std::chrono::steady_clock::time_point end;
	static bool game;
	static bool Globalgameover;
	static bool Globalnextstage;
	static bool Globalfirststage;
	static bool GlobalReset;
	static bool GlobalResetDone;
	static int score;
	static int lives;
	static long double timeBucket;
	static long double timeDelta;
	static long double sleepTime;
	static int EnemiesLeft;
	static bool Pause;
	static bool restart;
	static bool durchgeschafft;
	static bool newHighScore;
	static std::string globalNewName;
	static bool loadUfo;

	//globals for enemy movement
	static bool go;
	static bool right;
	static bool left;
	static bool down;
	static bool nextDownthenRight;
	static bool nextDownthenLeft;
	static bool wentDown;
	static SDL_Rect RightBorder;
	static SDL_Rect LeftBorder;
	static long double moveTreshold;
	static int levelup;

	//for player laser
	static SDL_Rect PlayerLaserRect;
	static bool PlayershotFired;
	static bool PlayerlaserCollide;

	//DEMO MODE STUFF
	static bool demoMode;
	static int GloballaserStartX;
	static int GloballaserStartY;
	static int GloballaserEndX;
	static int GloballaserEndY;

	//ENEMY LASER
	static SDL_Rect enemyLaserRect[55];
	static int enemyLaserStartX[55]; static int enemyLaserEndX[55]; static int enemyLaserStartY[55]; static int enemyLaserEndY[55];
	static bool enemyLaserActive[55];
	static bool playerHit;

	//Enemies
	static SDL_Rect UFOTarget;
	static SDL_Texture * UFOTexture;
	static SDL_Surface * UFOSurface;
	static bool UFO_active;

	static SDL_Rect littleGreyTarget[11];
	static SDL_Texture * littleGreyTexture;
	static SDL_Surface * littleGreySurface;
	static bool littleGreyDead[11];

	static SDL_Rect tripodBodyTarget[22];//Body mit Beinen nach unten erweitern
	static SDL_Texture * tripodBodyTexture;
	static SDL_Surface * tripodBodySurface;

	static SDL_Rect takoTarget[22];
	static SDL_Texture * takoTexture;
	static SDL_Surface * takoSurface;

	//the wall (breaks when hit by player or enemy laser, game over when enemy collides with it)  
	static SDL_Rect BarrierTarget[380];
	
	static SDL_Texture * barrierTexture;
	static SDL_Surface * barrierSurface;
	static SDL_Rect barrierSource;

	//when hit: explode and burst into pieces
	static SDL_Rect explosionTarget[56];
	static bool explosionActive[56];
	static SDL_Texture *explosionTexture;
	static SDL_Surface *explosionSurface;

	static SDL_Rect FragmentTarget[1810];//1809
	static int LegStartX[66]; 
	static int LegEndX[66]; 
	static int LegStartY[66]; 
	static int LegEndY[66];
	static bool fragmentActive[1810];//1809
	
	//static FX FX_QUEUE[2371];
	//static int lastSoundSlot;

	static void restartVars(long double &moveTreshold, int &EnemiesLeft, int&globalLives, int &globalScore, int &levelup, int &stage, bool&right, bool&left, bool&down, bool&wentDown, bool&nextDownthenLeft, bool&nextDownthenRight, bool &durchgeschafft, bool &startScreen, bool &GlobalGameover);
	static void movement(bool &left, bool &right, bool &down, bool &wentdown, bool &nextDownthenLeft, bool&nextDownthenRight);
	static void NextOrGameOver(bool &GlobalReset, bool &GlobalResetDone, int &EnemiesLeft, int &stage, bool &durchgeschafft,	bool &Globalgameover, bool &UFO_active, bool &Globalnextstage);
	static void DoReset(bool GlobalReset, int &levelup, bool &GlobalResetDone, int &EnemiesLeft, bool &right, bool &left, bool &nextDownthenRight, bool&nextDownthenLeft, long double &moveTreshold);
	static void DestroyGlobals(SDL_Surface *&UFOSurface, SDL_Texture *&UFOTexture, 	SDL_Surface *&littleGreySurface, SDL_Texture *&littleGreyTexture, SDL_Surface *&tripodBodySurface, SDL_Texture *&tripodBodyTexture,
	SDL_Surface *&takoSurface, SDL_Texture *&takoTexture, SDL_Surface *&barrierSurface, SDL_Texture *&barrierTexture, SDL_Surface *&explosionSurface, SDL_Texture *&explosionTexture, SDL_Renderer *&renderer, SDL_Window *&window, TTF_Font *&font);
	
	Thing()
	{
	}

	virtual ~Thing()
	{
	}
	
	virtual void initiate(int i) = 0;
	virtual void update(int i) = 0; //PURE VIRTUAL
	virtual void destroy(int i) { 0 == 0; };

};

